; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_POWER_DOWN:
	; SI4739 aus	
	STS(adr_FREQUENZ_AM_FM_L),NULL
	STS(adr_FREQUENZ_AM_FM_H),NULL
	STS(adr_MODUS_AM_FM),NULL
	rcall RDS_CLEAR								; RDS clear

	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(POWER_DOWN)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	rcall TWI_STOP								; STOPP		
	STS(adr_MODUS_AM_FM),NULL
	rjmp wait_100ms
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_INT_STATUS_WAIT:
	rcall SI4735_GET_INT_STATUS
	LDS temp,(adr_STATUS)
	andi temp,0x80
	tst temp
	breq SI4735_INT_STATUS_WAIT_w
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	ret
SI4735_INT_STATUS_WAIT_w:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	rcall wait_100ms
	rjmp SI4735_INT_STATUS_WAIT
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Bit 	D7 	D6 	D5 	D4 	D3 		D2 		D1 	D0									
;STATUS CTS	ERR X 	X 	RSQINT 	RDSINT 	X 	STCINT								
; Bit7 CTS 		= Clear to Send. 0 = Wait before sending next command. 1 = Clear to send next command.
; Bit6 ERR 		= Error. 0 = No error 1 = Error														
; Bit3 RSQINT 	= Received Signal Quality Interrupt. 0 = Received Signal Quality measurement has not been triggered.1 = Received Signal Quality measurement has been triggered.
; Bit2 RDSINT 	= Radio Data System (RDS) Interrupt. 0 = Radio data system interrupt has not been triggered.1 = Radio data system interrupt has been triggered.
; Bit0 STCINT 	= Seek/Tune Complete Interrupt. 0 = Tune complete has not been triggered. 1 = Tune complete has been triggered.
SI4735_GET_INT_STATUS:
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(GET_INT_STATUS)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	rcall TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; MR-START	
	rcall TWI_MASTER_RECEIVER_NO_ACK_TEMP1		; STATUS	
	STS(adr_STATUS),temp1
	rcall TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	; ERROR		
	LDS temp,(adr_STATUS)
	andi temp,0b01000000
	tst temp
	brne SI4735_GET_INT_STATUS_ERROR
	ret
SI4735_GET_INT_STATUS_ERROR:
	ldi temp,(ERROR_INT_STATUS)
	rjmp ERROR_SPEICHERN_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 0 0 1 0 0 1 0															
; ARG1 0 0 0 0 0 0 0 0															
; ARG2 Property High Byte.		(temp2)											
; ARG3 Property Low Byte.		(temp1)											
; ARG4 Property Value High Byte.(temp4)											
; ARG5 Property Value Low Byte.	(temp3)											
SI4735_SET_PROPERTY_TEMP1_4:
	push temp3
	push temp4
	push temp1
	push temp2

	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1; MT-START	
	ldi temp1,(SET_PROPERTY)
	rcall TWI_MASTER_TRANSMITTER_TEMP1		; CMD		
	ldi temp1,0			; NULL
	rcall TWI_MASTER_TRANSMITTER_TEMP1		; ARG 1		

	pop temp1 ; (temp2)
	rcall TWI_MASTER_TRANSMITTER_TEMP1		;Property High Byte			(temp2)	
	pop temp1 ; (temp1)
	rcall TWI_MASTER_TRANSMITTER_TEMP1		;Property Low Byte			(temp1)	
	pop temp1 ; (temp4)
	rcall TWI_MASTER_TRANSMITTER_TEMP1		;Property Value High Byte	(temp4)	
	pop temp1 ; (temp3)
	rcall TWI_MASTER_TRANSMITTER_TEMP1		;Property Value Low Byte 	(temp3)	

	rcall TWI_STOP							; STOPP		

	rjmp SI4735_INT_STATUS_WAIT				; wait...
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD  0 0 0 1 0 0 1 0															
; ARG1 0 0 0 0 0 0 0 0															
; ARG2 Property High Byte.		(temp2)											
; ARG3 Property Low Byte.		(temp1)											
;																				
;Response:																		
; Bit 		D7 	D6 	D5 	D4 	D3 		D2 		D1 	D0								
; STATUS 	CTS ERR X 	X 	RSQINT 	RDSINT 	X 	STCINT							
; RESP1 	0 	0 	0 	0 	0 		0 		0 	0								
; RESP2 	Property Value High Byte.	(temp2)											
; RESP3 	Property Value Low Byte.	(temp1)											
SI4735_GET_PROPERTY_TEMP1_2:
	push temp1
	push temp2
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_TRANSMITTER_START_TEMP1	; MT-START	
	ldi temp1,(GET_PROPERTY)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; CMD		
	ldi temp1,0		
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG 1 (NULL)				
	pop temp1 ; (temp2)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG 2 Property High Byte	
	pop temp1 ; (temp1)
	rcall TWI_MASTER_TRANSMITTER_TEMP1			; ARG 3 Property Low Byte	
	rcall TWI_STOP								; STOPP		
;-------------------------------------------------------------------------------
	ldi temp1,(TWI_ADRESSE_RADIO)
	rcall TWI_MASTER_RECEIVER_START_TEMP1		; MR-START	

	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; STATUS	
	STS(adr_STATUS),temp1				; STATUS	
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP1		
										; DUMMY
	rcall TWI_MASTER_RECEIVER_ACK_TEMP1			; RESP2		;Property Value HIGH Byte.
	mov temp2,temp1					
	rcall TWI_MASTER_RECEIVER_NO_ACK_TEMP1		; RESP3		;Property Value Low Byte.	
	rjmp TWI_STOP								; STOPP		
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RX_VOLUME	(0...63 default is 63 dB)											
SI4735_RX_VOLUME_WRITE_TEMP1:
	; auf 63 begrenzen		
	cpi temp1,(63+1)
	brlo SI4735_RX_VOLUME_WRITE_TEMP1_w
	ldi temp1,63
SI4735_RX_VOLUME_WRITE_TEMP1_w:
	push temp1			; KOPIE
	ldi temp1,LOW (RX_VOLUME)			;Property Low Byte			
	ldi temp2,HIGH(RX_VOLUME)			;Property High Byte			
	pop temp3			; (temp1)		;Property Value Low Byte	
	ldi temp4,0							;Property Value High Byte	
	rcall SI4735_SET_PROPERTY_TEMP1_4
	; auslesen				
	rjmp SI4735_RX_VOLUME_READ_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_RX_VOLUME_READ_TEMP1:
	ldi temp1,LOW (RX_VOLUME)			;Property Low Byte
	ldi temp2,HIGH(RX_VOLUME)			;Property High Byte
	rcall SI4735_GET_PROPERTY_TEMP1_2
	STS(adr_VOLUME_IST),temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_RX_VOLUME_PLUS:
	; Lautstrke (normal)	
	LDS temp,(adr_VOLUME_NORMAL)
	subi temp,(-4)
	; begrenzen				
	cpi temp,(63+1)
	brlo SI4735_RX_VOLUME_PLUS_w
	ldi temp,63
SI4735_RX_VOLUME_PLUS_w:
	STS(adr_VOLUME_NORMAL),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_RX_VOLUME_MINUS:
	; Lautstrke (normal)	
	LDS temp,(adr_VOLUME_NORMAL)
	dec temp
	; begrenzen				
	tst temp
	brpl SI4735_RX_VOLUME_MINUS_w
	ldi temp,0
SI4735_RX_VOLUME_MINUS_w:
	STS(adr_VOLUME_NORMAL),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SI4735_LAUTSTAERKE_TA:
	; Lautstrke (TA)		
	LDS temp1,(adr_VOLUME_NORMAL)
	ldi temp,(LAUTSTAERKE_ANHEBUNG_TA)
	add temp1,temp
	; begrenzen				
	cpi temp1,(63+1)
	brlo SI4735_LAUTSTAERKE_TA_w
	ldi temp1,63
SI4735_LAUTSTAERKE_TA_w:
	STS(adr_VOLUME_TA),temp1
;-------------------------------------------------------------------------------
	; TP aktiv ?						
	LDS temp,(adr_RDS_TP)
	tst temp
	breq SI4735_FM_LAUTSTAERKE_NORMAL
	; TA aktiv ?						
	LDS temp,(adr_RDS_TA)
	tst temp
	brne SI4735_FM_LAUTSTAERKE_TA_LAUT
;-------------------------------------------------------------------------------
SI4735_FM_LAUTSTAERKE_NORMAL:
	LDS temp1,(adr_VOLUME_NORMAL)
	LDS temp2,(adr_VOLUME_IST)
	cp temp1,temp2
	brne SI4735_FM_LAUTSTAERKE_NORMAL_w
	ret
SI4735_FM_LAUTSTAERKE_NORMAL_w:
	rjmp SI4735_RX_VOLUME_WRITE_TEMP1
;-------------------------------------------------------------------------------
SI4735_FM_LAUTSTAERKE_TA_LAUT:
	LDS temp1,(adr_VOLUME_TA)
	LDS temp2,(adr_VOLUME_IST)
	cp temp1,temp2
	brne SI4735_FM_LAUTSTAERKE_TA_LAUT_w
	ret
SI4735_FM_LAUTSTAERKE_TA_LAUT_w:
	rjmp SI4735_RX_VOLUME_WRITE_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
